function [ap_signal, function_weight] = apodization(FID, type, para)

tmp = size(FID);
if (tmp(2) > 1), FID = FID'; end

[N, Nx] = size(FID);
n_t = ((0:N - 1)) / para(1);
n = 0:N - 1;
function_weight = ones(N, Nx);

switch type
    case 1 %No apodization
        ap_signal = FID;
        return

    case 2 % Lorentz-Gauss
        if ((para(2) == 0) && (para(2) == 0))
            ap_signal = FID;
            return
        else
            a1 = (pi * para(2));
            a2 = (pi * para(2)) / 2 * sqrt(log(2));
            w = exp(-(a1 * n_t + (a2^2) * (n_t .* n_t)));
        end

    case 3 %Lorentz
        if (para(2) == 0)
            ap_signal = FID;
            return
        else
            a = (pi * para(2));
            w = exp((-a)*n_t);
        end

    case 4 %Gauss
        if (para(2) == 0)
            ap_signal = FID;
            return
        else
            a = (pi * para(2)) / 2 * sqrt(log(2));
            w = exp(-((n_t) .* (n_t))*(a^2));
        end

    case 5 % Sigmoid
        if (para(2) == 0)
            ap_signal = FID;
            return
        else
            w = 1 ./ (1 + exp(0.05 * (n - para(2))));
        end

end
weight_mat = repmat(w', [1, Nx]);
function_weight = weight_mat;
ap_signal = weight_mat .* FID;