function gui (c)
%% ZAKLADNI PROMENNE
% ukladani nactenych signalu
signals = [];
% ukladani transformovanych signalu
transformed = [];

% zakl. parametry
maxParaValue = 100;
Fs = 16000;
f0 = 81.154;
BW = 6720.43;
para = [Fs, 1];
border = BW / (2 * f0);
showItgInt = true;
showSNRborder = true;
ILeftLine = 0;
IRightLine = 0;
SNRborder1 = [];
SNRborder2 = [];
SNRborderLine1 = 0;
SNRborderLine2 = 0;
newnewVal = 0;
newVal = 0;

% rozliseni vychoziho okna
windowRatio = 21 / 11;
width = 1200;
height = width / windowRatio;

f = figure('Visible', 'off', 'Position', [100, 100, width, height], ...
    'Name', 'Spectra Viewer', 'NumberTitle', 'off');
f = handle(f);
%% ROZMERY UZITE PRI DEFINOVANI OBJEKTU
% rozmery, vzdalenosti objektu
spcX = 0.025;
spcY = spcX / windowRatio;

buttWd = 0.25;
buttHg = 0.09;

popupWd = 0.25;
popupHg = 0.09;

listWd = 0.25;
listHg = 2* buttHg - 0.1*spcY ;

plotWd = 1 - 2 * spcX * 2;
plotHg = 1 - 2 * spcY * 5;
%% VYTVORENI DVOU KONTEJNERU - OVLADACI A ZOBRAZOVACI
%definice dvou zakladnich objektu/kontejneru - ovlacaci a graf
ControlContainer = uipanel('Parent', f, 'Title', 'Control Panel', ... 
    'FontSize', 18, 'BackgroundColor', 'white', ...
    'Position', [0, 0, 0.5, 1]);
ControlContainer = handle(ControlContainer);

PlotContainer = uipanel('Parent', f, 'Title', 'Spectrogram', ...
    'FontSize', 18, 'Units', 'normalized', 'BackgroundColor', 'white', ...
    'Position', [0.27, 0, 0.73, 1]);
PlotContainer = handle(PlotContainer);
%% DEFINOVANI OBJEKTU KTERE SE NACHAZEJI V OVLADACIM KONTEJNERU
%definice objektu nachazejici se v ovladacim kontejneru
%%
signalsList = uicontrol('Parent', ControlContainer, 'Style', 'listbox', ... 
    'Units', 'normalized', ...
    'Position', [spcX, 1- 1.5*listHg - spcY, listWd, listHg*1.5]);
signalsList = handle(signalsList);

selectFileButton = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', 'Choose FID Signal', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [buttWd + 1.2*spcX, 1 - buttHg - spcY, buttWd, buttHg], ...
    'TooltipString', ['You can add multiple', char(10), ...
          'FID signals.'],...
    'Callback', @selectFile);
selectFileButton = handle(selectFileButton);

displayDeleteButton = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', 'Delete chosen signal', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [buttWd + 1.2*spcX, 1 - 2 * buttHg - spcY, buttWd, buttHg], ...
    'TooltipString', ['Will delete chosen signal,', char(10), ...
        '(marked blue).'], ...
    'Callback', @removeSignal);
displayDeleteButton = handle(displayDeleteButton);
%%
stringSNR = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', '', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX, 1 - 4 * buttHg+spcY*2, buttWd, buttHg*0.5]);
stringSNR = handle(stringSNR);

apodizationTypeString = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', '     Apodization type', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX, 1 - 4 * buttHg+spcY*2, buttWd, buttHg*0.5]);
apodizationTypeString = handle(apodizationTypeString);

apodizationInfo = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', '?', 'FontSize', 11, 'fontweight','bold', 'Units', 'normalized', ...
    'TooltipString', ['To apodize the signal, choose type' , char(10), ...
    'of apodization first after that you can' , char(10), ...
    'set its rate using slider on the right.'], ...
    'Position', [spcX, 1 - 4 * buttHg+spcY*2, buttWd*0.2, 0.5*buttHg]);
apodizationInfo = handle(apodizationInfo);

popupMenuApodization = uicontrol('Parent', ControlContainer, 'Style', 'popupmenu', ...
    'String', {'No apodization', 'Lorentz-Gauss', 'Lorentz', 'Gauss', 'Sigmoid'}, ...
    'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX, 1 - 5 * buttHg+spcY*2, buttWd, popupHg], ...
    'Callback', @selectTransformType);
popupMenuApodization = handle(popupMenuApodization);

apodizationValueString = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Apodization Value: 0', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [buttWd + 1.2*spcX, 1 - 4 * buttHg+spcY*2, buttWd, buttHg*0.5]);
apodizationValueString = handle(apodizationValueString);

apodizationValueSlider = uicontrol('Parent', ControlContainer, 'Style', 'Slider', ...
    'Min', 0, 'Max', maxParaValue, 'SliderStep', [0.01, 0.15], ...
    'FontSize', 11, 'Units', 'normalized', ...
    'Position', [buttWd + 1.2*spcX, 1 - 5 * buttHg + 5.5*spcY, popupWd, 0.04], ...
    'Callback', @sliderChange);
apodizationValueSlider = handle(apodizationValueSlider);
%%
calcSNR = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', '    Calculate SNR', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [1.2*spcX + buttWd, 1 - 5.5 * buttHg-spcY, buttWd, buttHg], ...
    'Callback', @noiseChoose);
calcSNR = handle(calcSNR);

valSNR = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'SNR: null', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [buttWd + 1.2*spcX,4.5 * buttHg+3*spcY, buttWd, 0.04]);
valSNR = handle(valSNR);

SNRinfo = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', '?', 'FontSize', 11, 'fontweight', 'bold', 'Units', 'normalized', ...
 'TooltipString', ['To receive SNR value of a peak, locate your' , char(10), ...
        'desired peak using slider below, then you' , char(10), ...
    'can press ''Calculate SNR'' and see the result.'], ...
    'Position', [1.2*spcX + buttWd,  1 - 5 * buttHg-spcY, buttWd*0.2, 0.5*buttHg]);
SNRinfo = handle(SNRinfo);

noiseGroup = uibuttongroup('Parent', ControlContainer,'Visible','off', ...
    'Units','normalized', ...
'Position',[spcX,5 * buttHg+3.5*spcY, buttWd, buttHg],'SelectionChangeFcn',@noiseChoose);
noiseValStd = uicontrol(noiseGroup, 'Style', 'radiobutton', ...
'String', 'Standard Deviation', 'FontSize', 11, 'Units', 'normalized', ...
 'Position', [0.5*spcX,buttHg*7, buttWd*3.8, buttHg*3]);
noiseValStd = handle(noiseValStd);

noiseValPeakToPeak = uicontrol(noiseGroup, 'Style', 'radiobutton', ...
'String', 'Peak to Peak', 'FontSize', 11, 'Units', 'normalized', ...
 'Position', [0.5*spcX,buttHg*2, buttWd*3.8, buttHg*3]);
noiseValPeakToPeak = handle(noiseValPeakToPeak);
noiseGroup = handle(noiseGroup);
set(noiseGroup,'Visible','on');

peakLocation = uicontrol('Parent', ControlContainer, 'Style', 'slider', ...
    'Min',-border-5,'Max',+border+1,'SliderStep', [0.01, 0.15],'Value',0, ...
    'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX,1 - 6 * buttHg-spcY, buttWd, 0.04], ...
    'Callback', @selectPeaks);
peakLocation = handle(peakLocation);
%%
linewidthstring = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Set Line Width: 1.0', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [1.2*spcX+buttWd, 1- 3*buttHg, buttWd, buttHg*0.8], ...
    'Callback', @sirkaText);
linewidthstring = handle(linewidthstring);

linewidthSlider = uicontrol('Parent', ControlContainer,'Style','Slider', ...
    'Min',1,'Max',5,'SliderStep', [0.025, 0.15],'Value',1, 'FontSize', 11, ...
    'Units', 'normalized', ...
    'Position', [1.2*spcX+buttWd, 1- 3*buttHg-spcY,  popupWd, 0.04], ...
    'Callback', @Sirka);
linewidthSlider = handle(linewidthSlider);
%%
savePhoto = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', 'Save Photo of a Graph', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [1.2*spcX,spcY, buttWd, buttHg], ...
    'Callback', @Foto);
savePhoto = handle(savePhoto);
%%
valIntegral = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Integral: null', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [1.2*spcX + buttWd,2*spcY+2*buttHg, buttWd, buttHg*0.75]);
valIntegral = handle(valIntegral);

calcIntegral = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', '     Calculate Integral', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [1.2*spcX + buttWd, buttHg + spcY+2*buttHg, buttWd, buttHg], ...
    'Callback', @integral);
calcIntegral = handle(calcIntegral);

leftStringText = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Border 1:', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [spcX, buttHg + spcY+2*buttHg,  0.5*buttWd+1.1*spcX, buttHg], ...
    'Callback', @leftTextString);
leftStringText = handle(leftStringText);

leftSliderString = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', '0 ppm', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [buttWd*0.5+spcX, buttHg + spcY+2*buttHg,  0.5*buttWd, buttHg], ...
    'Callback', @LevaText);
leftSliderString = handle(leftSliderString);

leftSlider = uicontrol('Parent', ControlContainer,'Style','Slider', ...
    'Min',-border-0.2,'Max',+border+0.2,'SliderStep', [0.001, 0.15],'Value',0, ...
    'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX, buttHg + spcY+2*buttHg, popupWd, 0.04], ...
    'Callback', @Leva);
leftSlider = handle(leftSlider);

rightStringText = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Border 2:', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [spcX, spcY+2*buttHg, 0.5*buttWd+1.1*spcX, buttHg], ...
    'Callback', @rightTextString);
rightStringText = handle(rightStringText);

rightSliderString = uicontrol('Parent', ControlContainer, 'Style', 'text', ...
    'String', '0 ppm', 'Units', 'normalized', 'FontSize', 11, ...
    'Position', [buttWd*0.5+spcX, spcY+2*buttHg, 0.5*buttWd, buttHg], ...
    'Callback', @PravaText);
rightSliderString = handle(rightSliderString);

rightSlider = uicontrol('Parent', ControlContainer,'Style','Slider', ...
    'Min',-border-0.2,'Max',border+0.2,'SliderStep', [0.001, 0.15],'Value',0, ...
    'FontSize', 11, 'Units', 'normalized', ...
    'Position', [spcX, spcY+2*buttHg, popupWd, 0.04], ...
    'Callback', @Prava);
rightSlider = handle(rightSlider);

defineIntegralBorders = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', '?', 'FontSize', 11, 'fontweight', 'bold', 'Units', 'normalized', ...
    'TooltipString', ['To calculate area under the curve, set' , char(10), ...
    'its borders using sliders below firstly,' , char(10), ...
    ' then you can press ''Calculate Integral''.'], ...
    'Position', [1.2*spcX + buttWd, 1.5*buttHg + spcY+2*buttHg, buttWd*0.2, 0.5*buttHg], ...
    'Callback', @defineBorders);
    defineIntegralBorders = handle(defineIntegralBorders);
%%
    diarySave = uicontrol('Parent', ControlContainer, 'Style', 'pushbutton', ...
    'String', 'Export Value Data', 'FontSize', 11, 'Units', 'normalized', ...
    'Position', [1.2*spcX + buttWd,spcY, buttWd, buttHg], ...
    'Callback', @diary);
    diarySave = handle(diarySave);
%% DEFINOVANI VZHLEDU GRAFU
%definice objektu kontejneru s grafem
plotField = axes('Parent', PlotContainer, ...
    'Position', [3 * spcX, 6.5 * spcY, plotWd, plotHg-0.01], 'Box', 'on');
plotField = handle(plotField);

plotField.XLabel = handle(plotField.XLabel);
set(plotField.XLabel, 'String', 'Frequency [ppm]');
set(plotField.XLabel, 'FontSize', 15.5);
set(plotField.XLabel, 'FontUnits', 'normalized');

plotField.YLabel = handle(plotField.YLabel);
set(plotField.YLabel, 'String', 'Amplitude [arb. u.]');
set(plotField.YLabel, 'FontSize', 15.5);
set(plotField.YLabel, 'FontUnits', 'normalized');

plotField.FontUnits = 'normalized';
xlim([-border, border])
set(gca, 'xdir', 'reverse')
grid on;

f.Units = 'normalized';

selectFileButton.FontUnits = 'normalized';
popupMenuApodization.FontUnits = 'normalized';
apodizationValueSlider.FontUnits = 'normalized';
signalsList.FontUnits = 'normalized';
apodizationValueString.FontUnits = 'normalized';
apodizationTypeString.FontUnits = 'normalized';
calcSNR.FontUnits = 'normalized';
valSNR.FontUnits = 'normalized';
calcIntegral.FontUnits = 'normalized';
valIntegral.FontUnits = 'normalized';
SNRinfo.FontUnits = 'normalized';
displayDeleteButton.FontUnits = 'normalized';
displayDeleteButton.FontAngle = 'italic';
linewidthstring.FontUnits = 'normalized';
defineIntegralBorders.FontUnits = 'normalized';
apodizationInfo.FontUnits = 'normalized';
noiseValPeakToPeak.FontUnits = 'normalized';
noiseValStd.FontUnits = 'normalized';
rightSliderString.FontUnits = 'normalized';
leftSliderString.FontUnits = 'normalized';
rightStringText.FontUnits = 'normalized';
leftStringText.FontUnits = 'normalized';
savePhoto.FontUnits = 'normalized';
diarySave.FontUnits = 'normalized';
% Zobrazeni GUI
f.Visible = 'on';

%% FUNKCE A CALLBACKY
%%
    function selectFile(source, eventdata)
        % otvira dialogovy okno s cestou pro slozku
        [flName, flPath] = uigetfile('*.*');
        if isa(flName, 'double') && isa(flPath, 'double'), return;
        end
        fullName = [flPath, flName];

        % otvira a cte slozky
        fileId = fopen(fullName, 'rb');
        FID = fread(fileId, 'int32');

        % preprocessing
        rl = -FID(1:2:end);
        im = -FID(2:2:end);
        FID = rl + 1i * im;
        
        data=length(FID);
        p = c-1;
        X = zeros(1,p*data);
        X = X';
        
        z=[FID; X];
        % ZERO-FILLING
        signal = (z);
        [smth max_index] = max(signal);
        if max_index > 1
            signal = [signal(max_index:end); ...
                zeros(max_index - 1, 1)];
        end
        
        % pridani signalu
        signals = [signals; signal'];
        addSignal(fullName, length(signals)+1);
        transformSignal(true);
        displaySignals(source, eventdata);
    end
%%
    function Sirka (source, eventdata)
         transformSignal(true);
        displaySignals(source, eventdata);
        valSirka = get(source, 'Value');
        valSirka = round(valSirka*10)/10;
       set(linewidthstring, 'String', num2str(valSirka, 'Line Width: %.1f'));
    end
%% INTEGRAL
        function integral (source, eventdata)
       if (length(signals) < 1), return; end
          index = signalsList.Value;
          signal = transformed(index, :);
          valMax = max(signal);
          le = length(signal);
         ppm2samples = le/(BW/f0);
         
         left = get(leftSlider,'Value');
         left1 = get(leftSlider,'Value');
         right = get(rightSlider,'Value');
         right1 = get(rightSlider,'Value');
         left = round((length(signal)/2)+(ppm2samples*(left)));
         right = round((length(signal)/2)+(ppm2samples*(right)));
        
         if right < left
                    Int=trapz(abs(signal(right:left))); 
                    set(valIntegral, 'String', num2str(Int, '%10.2e'))
                ppm_border1 = -left1;
                ppm_border2 = -right1;
                Integral = Int;
          else 
                Int=trapz(abs(signal(left:right))); 
                set(valIntegral, 'String', num2str(Int, '%10.2e'))
                ppm_border1 = -left1;
                ppm_border2 = -right1;
                Integral = Int;
         end  
          if ppm_border1 == ppm_border2
              set(valIntegral, 'String', 'You must set unequal integral borders.');
          end
     end
 %%
function Leva (source, eventdata)
    ILeftLine = side(source,ILeftLine, leftSliderString);
end
%% 
    function Prava (source, eventdata) 
    IRightLine = side(source, IRightLine, rightSliderString);
    end
%%
function line = side(source, line, slider,IRightLine, ILeftLine)
    if (length(signals) < 1 || ~showItgInt), return; end
    
    index = signalsList.Value;
    transformSignal();
    
    signal = transformed(index, :);
    valMax = max(signal);
    
    val = get(source, 'Value');
    val = round(-1*val*10)/10;
    
    hold on;
        
    if (isa(line,'handle')), delete(line); end
    line = handle(plot([val val], [0 valMax], '--r', 'LineWidth',1.5));
        
    set(slider, 'String', num2str(val, '%.1f ppm'));
end
%%
    function selectTransformType(source, eventdata)
    end
% hodnota posuvniku
    function sliderChange(source, eventdata)
        transformSignal(true);
        displaySignals(source, eventdata);
        val = get(source, 'Value');
        val = floor(val);
        set(apodizationValueString, 'String', num2str(val, 'Apodization Value: %.f'));
    end

%% pridani do signalu do signal listu
    function addSignal(name, id)
        [index smth] = size(signals);
        signalsList.String{end+1} = [num2str(index), '. ', name];
        signalsList.UserData = [signalsList.UserData; cellstr(name), id];
    end
%% prevedeni do ppm
    function ppm = adjustAxis(BW, f, len)
        step = BW / len / f;
        border = BW / (2 * f);
        ppm = -border:step:border - step;
        set(gca, 'xdir', 'reverse')
    end
%% transformovani signalu (fft) v zavislosti na apodizaci
    function transformSignal(retransform)
        if nargin < 1 || isempty(retransform), retransform = false; end

        [sgnCnt, smth] = size(signals);
        [trfCnt, smth] = size(transformed);
        if (sgnCnt < 1), return; end

        st = 0; %pocatek signalu
        fn = sgnCnt; %konec signalu
        if (~retransform), st = trfCnt + 1;
        else, st = 1; end

        if (retransform || sgnCnt > trfCnt)
            for i = st:fn
                signal = signals(i, :);
                if (popupMenuApodization.Value ~= 6)
                    [signal smth] = apodization(signal, popupMenuApodization.Value, ...
                    [para(1), para(2) .* apodizationValueSlider.Value]);
                end
                transformed(i, :) = abs(fftshift(fft(signal)));
            end
        end
    end
%%  zobrazeni transformovaneho signalu v grafu
    function displaySignals(source, eventdata)

        transformSignal();

        hold on;
        cla;
        newXAxis = adjustAxis(BW, f0, length(transformed));
        plot(plotField, newXAxis, transformed, 'LineWidth',get(linewidthSlider,'Value'));   
        xlim([-border, border])
        grid on;
        IRightLine = 0;
        ILeftLine = 0;
        SNRborderLine1 = 0;
        SNRborderLine2 = 0;
    end

    function selectPeaks (source,eventdata)
          if (length(signals) < 1), return; end
          index = signalsList.Value;
          signal = transformed(index, :);
          
          le=length(signal);
          sampleTOppm = le/(BW/f0);
         
         SNRborder1= get(peakLocation,'Value');
         SNRborder1 = round((length(signal)/2)+(sampleTOppm*(SNRborder1)));
         SNRborder2 = SNRborder1+100;
         SNRborderLine1 = sidel(source,SNRborderLine1);
         SNRborderLine2 = sidelz(source,SNRborderLine2);
    end

         function linex = sidel(source, linex, slider,SNRborderLine1)
    if (length(signals) < 1 || ~showSNRborder), return; end
    
    index = signalsList.Value;
    transformSignal();
    
    signal = transformed(index, :);
    valMax = max(signal);
    
    val = get(source, 'Value');
    val = round(val*10)/10;
    newVal = val;
    hold on;
     
    if (isa(linex,'handle')), delete(linex); end
    linex = handle(plot([newVal newVal], [0 valMax], '-.m', 'LineWidth',1.5));
         end

    function linez = sidelz(source, linez, slider,SNRborderLine2)
    if (length(signals) < 1 || ~showSNRborder), return; end
    
    index = signalsList.Value;
    transformSignal();
    
    signal = transformed(index, :);
    valMax = max(signal);

    val = get(source, 'Value');
    val = round(val*10)/10;
    newVal = -val;
    newnewVal = -newVal+(0.404*10);
   
    hold on;
      
    if (isa(linez,'handle')), delete(linez); end
    linez = handle(plot([newnewVal  newnewVal], [0 valMax], '-.m', 'LineWidth',1.5));
    end
        
function noiseChoose (source, eventdata)
    if get(noiseValStd,'Value')==1
        set(stringSNR, 'String','Standard Deviation');
    SNRstd
else
        set(stringSNR, 'String','Peak to Peak');
    SNRpeak
    end
end

    function SNRstd(source, eventdata)
        if (length(signals) < 1), return; end
        index = signalsList.Value;

        transformSignal();

        signal = transformed(index, :);
        signal = real(signal);
        MaxAmplitude=max(abs(signal(SNRborder1:SNRborder2)));
        stdVal = std(signal(1:floor(end * 0.15)));
        snr = (MaxAmplitude/stdVal);
        Peak_Amplitude = MaxAmplitude;
        set(valSNR, 'String', num2str(snr, '%.2f'));
   
        if newnewVal==newVal
            set(valSNR, 'String','Locate peak');
        end   
    end

 function SNRpeak(source, eventdata)
        if (length(signals) < 1), return; end
        index = signalsList.Value;

        transformSignal();

        signal = transformed(index, :);
        signal = real(signal);
        MaxAmplitude=max(abs(signal(SNRborder1:SNRborder2)));
		noiseValMax = max(signal(1:floor(end * 0.15)));
        noiseValMin = min(signal(1:floor(end * 0.15)));
        noiseVal = noiseValMax - noiseValMin;
        snr = (MaxAmplitude/noiseVal);
       
        set(valSNR, 'String', num2str(snr, '%.2f'));
        
        if newnewVal==newVal
            set(valSNR, 'String','Locate peak');
        end
 end
%%
    function Foto(source, eventdata)
        [FileName, PathName] = uiputfile('*.bmp', 'Save Photo');
            if (isequal(FileName, 0) || isequal(PathName, 0))
                % uivatel zmkl cancel
                return;
            end
        Name = fullfile(PathName, FileName);
        tmpFig = figure;
        tmpAxes = copyobj(plotField, tmpFig);    
        saveas(tmpFig, Name);
        delete(tmpFig);   
    end
%%
        function ret = sample2ppm(length)
            ret = length/(BW/f0);
            return
        end

        function ret = getMaxAmplitude(signal)
            ret = max(abs(signal(1 : length(signal))));
        end
    
        function diary (source,eventdata)
            
            if (length(signals) < 1), return; end
            
            fName = '';
            filter = {'*.txt'; '*.csv'; '*.xlsx'};
            [fName, path, indx] = uiputfile(filter, 'Export data', fName);
            
            if (isequal(fName, 0) || isequal(path, 0))
                % uivatel zmkl cancel
                return;
            end
              
            % bereme nazev/cestu vybranho souboru ze signal listu
            tmp = signalsList.String(signalsList.Value, :);
            sgnName = tmp{1}; 
            
            % integral
            intValue = valIntegral.String(:);
            intValue = intValue';
            intLeftBorder = num2str(leftSlider.Value);
            intRightBorder = num2str(rightSlider.Value);
            
            snrValue = valSNR.String(:);
            snrValue = snrValue';
            SNRborderDist = 50;
            
            noiseGroupType = stringSNR.String;
            
            amplitude = getMaxAmplitude(transformed(signalsList.Value, :));
            
            apodType = popupMenuApodization.String{popupMenuApodization.Value};
            apodValue = num2str(apodizationValueSlider.Value);
            
            if (indx == 3)
                % *.xlsx
                dataMatrix = {
                    'File Name' sgnName;
                    'Apodization Type', apodType;
                    'Apodization Parameter', apodValue; 
                    'Signal Amplitude' amplitude;
                    'Integral Value', intValue;
                    '1st Integral Border', intLeftBorder;
                    '2nd Integral Border', intRightBorder;
                    'SNR Value', snrValue;
                    'NoiseType', noiseGroupType;
                };
                xlswrite(fullfile(path, fName), dataMatrix)
                return;
            end
            
            file = fopen(fullfile(path, fName), 'wt');
            
            dlmtr = ': ';
            if (indx == 2) 
                % *.csv
                dlmtr = ',';
                writeVariable(file, 'Parameter', 'Value');
            end
            
            writeDelimiter(file, 'Information about this spectra');
            writeVariable(file, 'File Name', sgnName);
            writeVariable(file, 'Creation of this File', datestr(now, 'yy/mm/dd-HH:MM'));
            writeDelimiter(file, 'Apodization');
            writeVariable(file, 'Apodization Type', apodType);
            writeVariable(file, 'Apodization Parameter', apodValue);
            writeDelimiter(file, 'Amplitude');
            writeVariable(file, 'Signal Amplitude', amplitude);
            writeDelimiter(file, 'Integral');
            writeVariable(file, 'Integral Value', intValue);
            writeVariable(file, '1st Integral Border', intLeftBorder);
            writeVariable(file, '2nd Integral Border', intRightBorder);
            writeDelimiter(file, 'SNR');
            writeVariable(file, 'SNR Value', snrValue);
            writeVariable(file, 'Noise Type', noiseGroupType);
            
            fclose(file);
            
            function writeVariable(file, name, value)
                fprintf(file, '%s%s%s\n', name, dlmtr, value);
            end
            
            function writeDelimiter(file, title)
                if (indx == 2), return; end;
                fprintf(file, '\n<-========== %s ==========->\n', title);
            end
            
        end
    
% odebrani signalu ze signal listu
    function removeSignal(source, eventdata)
        
        if (length(signals) < 1), return; end
        index = signalsList.Value;

        signals(index, :) = [];

        [trfCnt smth] = size(transformed);
        if index <= trfCnt
            transformed(index, :) = [];
        end

        if (signalsList.Value ~= 1), signalsList.Value = index - 1; end
        signalsList.String(index, :) = [];
         transformSignal(true);
        displaySignals(source, eventdata);
    end
    end