function main
clc
clear
    
c = 0;

windowRatio = 21 / 11;
width = 600;
height = width / windowRatio;
spcX = 0.025;
spcY = spcX / windowRatio;

buttWd = 0.25;
buttHg = 0.09;

main = figure('Visible', 'off', 'Position', [500, 500, width, height], ...
    'Name', 'Spectra Viewer', 'NumberTitle', 'off',  'MenuBar', 'none');
main = handle(main);

ControlContainer = uipanel('Parent', main, 'Title', ...
    'Welcome to script intended for basic spectra analysis', ...
    'FontSize', 18, 'BackgroundColor', 'white', ...
    'Position', [0, 0, 1, 1]);
ControlContainer = handle(ControlContainer);

zero = uicontrol('Parent', ControlContainer, 'Style','Edit', ...
    'String',c,'FontSize', 13,'Units','normalized','Position', ...
[spcX * 15,  buttHg * 4 + spcY , buttWd, buttHg * 2],'Value',c, ...
'Callback', @zeroString); 
zero=handle(zero);

welcomezero1 = uicontrol ('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Start by entering the number of times you want to extend the signal with zero-filling. If you type 0 or non-numeric value, the signal will remain unchanged.', ...
    'BackgroundColor', 'white', 'FontSize', 13, 'Units', 'normalized', ...
    'Position', [0, 1 - 3 * buttHg, 1, buttHg*2]);
welcomezero1=handle(welcomezero1);

welcomezero2 = uicontrol ('Parent', ControlContainer, 'Style', 'text', ...
    'String', 'Please fill in multiples of two if you want to use zero-filling and receive better results (eg. 2, 4, 8, ...). ', ...
    'BackgroundColor', 'white', 'FontSize', 13, 'Units', 'normalized', ...
    'Position', [0, 1 - 5 * buttHg, 1, buttHg*2]);
welcomezero2=handle(welcomezero2);

close = uicontrol('Parent', ControlContainer, 'Style','pushbutton', ...
    'String','Confirm and Proceed to Main Script','FontSize', 13, ...
    'Units','normalized','Position', ...
    [spcX * 7,  buttHg , buttWd * 2.5, buttHg * 2], ...
    'Callback', @closeZero); 
close = handle(close);

main.Visible = 'on';

welcomezero1.FontUnits = 'normalized';
welcomezero2.FontUnits = 'normalized';
zero.FontUnits = 'normalized';
close.FontUnits = 'normalized';

function zeroString (source, eventdata)
        c = str2double(get(source,'String'));
        if (isnan(c)), c = 0; end
    end

     function closeZero (source, eventdata)
       set(main,'visible','off');
       gui (c);
     end

end